﻿using System;
using System.Collections.Generic;
using System.Web;
using MicroFour.StrataFrame.Business;

namespace WebApplication16.Common
{
    public class MyBasePage : MicroFour.StrataFrame.UI.Web.BasePage
    {
        private BusinessLayer _BO;

        public BusinessLayer PrimaryBO
        {
            get
            {
                return this._BO;
            }

            set
            {
                this._BO = value;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this._BO.Navigated += this.HandleNavigated;
        }

        protected void HandleNavigated(NavigatedEventArgs e)
        {
            this.OnNavigated(e);
        }

        protected virtual void OnNavigated(NavigatedEventArgs e)
        {
            if (this.Navigated != null)
            {
                this.Navigated(e);
            }
        }

        protected override void OnUnload(EventArgs e)
        {
            base.OnUnload(e);

            this._BO.Navigated -= this.HandleNavigated;
            this._BO = null;
        }

        public event NavigatedDelegate Navigated;

    }

    public delegate void NavigatedDelegate(NavigatedEventArgs e);

}
