using MicroFour.StrataFrame.Business;
using MicroFour.StrataFrame.Security;
using MicroFour.StrataFrame.UI.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;

namespace NotRefreshBusiness
{
    partial class EmployeeTerritoriesBO
    {

        #region Component Implementation

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            MicroFour.StrataFrame.Business.BusinessParentRelationship businessParentRelationship1 = new MicroFour.StrataFrame.Business.BusinessParentRelationship();
            // 
            // EmployeeTerritoriesBO
            // 
            businessParentRelationship1.ForeignKeyField = new string[] {
        "EmployeeID"};
            businessParentRelationship1.ParentBusinessObjectType = "NotRefreshBusiness.EmployeesBO";
            businessParentRelationship1.ParentPrimaryKeyField = new string[] {
        "EmployeeID"};
            this.ParentRelationship = businessParentRelationship1;
            this.CheckRulesOnCurrentRow += new MicroFour.StrataFrame.Business.BusinessLayer.CheckRulesOnCurrentRowEventHandler(this.EmployeeTerritoriesBO_CheckRulesOnCurrentRow);
            this.SetDefaultValues += new MicroFour.StrataFrame.Business.BusinessLayer.SetDefaultValuesEventHandler(this.EmployeeTerritoriesBO_SetDefaultValues);

        }

        #endregion


        #region BusinessLayer Overriden Methods & Properties

        /// <summary>
        /// The collection of required fields for the business object.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override RequiredFieldsCollection RequiredFields
        {
            get
            {
                return base.RequiredFields;
            }
            set
            {
                base.RequiredFields = value;
            }
        }

        /// <summary>
        /// Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override IBusinessParentRelationship ParentRelationship
        {
            get
            {
                return base.ParentRelationship;
            }
            set
            {
                base.ParentRelationship = value;
            }
        }

        /// <summary>
        /// Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
        /// </summary>
        protected override String AllFieldNames
        {
            get
            {
                return "[EmployeeID],[TerritoryID]";
            }
        }

        /// <summary>
        /// The name of the database that contains the table to which this business object is mapped.
        /// </summary>
        public override String Database
        {
            get
            {
                return "Northwind";
            }
        }

        private static string[] _PrimaryKeyFields = new string[] { "EmployeeID", "TerritoryID" };
        /// <summary>
        /// Gets the field or fields that comprise the primary key for the business object.
        /// </summary>
        public override string[] PrimaryKeyFields
        {
            get
            {
                return _PrimaryKeyFields;
            }
        }

        /// <summary>
        /// The name of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableName
        {
            get
            {
                return "EmployeeTerritories";
            }
        }

        /// <summary>
        /// The schema of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableSchema
        {
            get
            {
                return "dbo";
            }
        }

        /// <summary>
        /// Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
        /// </summary>
        protected override DataColumn[] CreateTableSchema()
        {
            return new DataColumn[] {
new DataColumn("EmployeeID", typeof(System.Int32)),
new DataColumn("TerritoryID", typeof(System.String))};
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected void AddBrokenRule(EmployeeTerritoriesBOFieldNames Field, string ErrorMessage)
        {
            base.AddBrokenRule(Field, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected new void AddBrokenRule(string FieldName, string ErrorMessage)
        {
            base.AddBrokenRule(FieldName, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected void AddBrokenRuleByKey(EmployeeTerritoriesBOFieldNames Field, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(Field, ErrorMessageKey);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected new void AddBrokenRuleByKey(string FieldName, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(FieldName, ErrorMessageKey);
        }

        /// <summary>
        /// Gets a collection of the names for all fields that belong to this business object and map to the database.
        /// </summary>
        public override List<string> AllFieldsList
        {
            get
            {
                return _AllFieldsList;
            }
        }

        /// <summary>
        /// Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
        /// </summary>
        public override Dictionary<string, DbType> FieldDbTypes
        {
            get
            {
                return _FieldDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
        /// </summary>
        public override BusinessLayerFieldEnumDictionary FieldEnums
        {
            get
            {
                return _FieldEnums;
            }
        }

        /// <summary>
        /// Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldLengths
        {
            get
            {
                return _FieldLengths;
            }
        }

        /// <summary>
        /// Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldNativeDbTypes
        {
            get
            {
                return _FieldNativeDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of the security permission keys for each field in the business object.
        /// </summary>
        public override Dictionary<string, string> FieldPermissionKeys
        {
            get
            {
                return _FieldPermissionKeys;
            }
        }

        #endregion

        #region Field Properties

        /// <summary>
        /// EmployeeID
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("EmployeeID"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 EmployeeID
        {
            get
            {
                return (System.Int32)this.CurrentRow["EmployeeID"];
            }
            set
            {
                this.CurrentRow["EmployeeID"] = value;
            }
        }

        /// <summary>
        /// TerritoryID
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("TerritoryID"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String TerritoryID
        {
            get
            {
                return (System.String)this.CurrentRow["TerritoryID"];
            }
            set
            {
                this.CurrentRow["TerritoryID"] = value;
            }
        }

        #endregion

        #region Field Property Events

        #endregion

        #region Nested Types & Field Security

        /// <summary>
        /// Contains all of the field names that belong to the business object.
        /// </summary>
        public enum EmployeeTerritoriesBOFieldNames
        {
            EmployeeID,
            TerritoryID,
            CUSTOM_FIELD
        }

        /// <summary>
        /// Gets the System.Type of the enumeration that contains the field names for the business object.
        /// </summary>
        public override System.Type GetFieldEnumType()
        {
            return typeof(EmployeeTerritoriesBOFieldNames);
        }

        /// <summary>
        /// Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
        /// </summary>
        protected override CheckFieldSecurityEventArgsBase CreateNewFieldSecurityEventArgs(System.Enum Field, string CustomField, string PermissionKey, PermissionInfo Perm)
        {
            return new CheckFieldSecurityEventArgs<EmployeeTerritoriesBOFieldNames>(Field, CustomField, PermissionKey, Perm);
        }

        /// <summary>
        /// Describes a method that will handle the CheckFieldScurity event.
        /// </summary>
        public delegate void CheckFieldSecurityEventHandler(object sender, CheckFieldSecurityEventArgs<EmployeeTerritoriesBOFieldNames> e);

        /// <summary>
        /// Occurs when the business objects needs to check the security on a field.
        /// </summary>
        public event CheckFieldSecurityEventHandler CheckFieldSecurity;

        /// <summary>
        /// Raises the CheckFieldSecurity event.
        /// </summary>
        protected override void OnCheckFieldSecurity(CheckFieldSecurityEventArgsBase e)
        {
            if (this.CheckFieldSecurity != null)
            {
                this.CheckFieldSecurity(this, (CheckFieldSecurityEventArgs<EmployeeTerritoriesBOFieldNames>)e);
            }
        }

        #endregion

        #region Item Property Implementation


        private static List<string> _AllFieldsList;
        private static Dictionary<string, DbType> _FieldDbTypes;
        private static BusinessLayerFieldEnumDictionary _FieldEnums;
        private static Dictionary<string, int> _FieldLengths;
        private static Dictionary<string, int> _FieldNativeDbTypes;
        private static Dictionary<string, string> _FieldPermissionKeys;

        /// <summary>
        /// Initializes the static members of the EmployeeTerritoriesBO class.
        /// </summary>
        static EmployeeTerritoriesBO()
        {
            //-- Create the new shared dictionary and populate it with an 
            //   instance of each property descriptor
            _PropertyDescriptors = new PropertyDescriptorDictionary(7);
            _PropertyDescriptors.Add("EmployeeID", new FieldDescriptor(EmployeeTerritoriesBOFieldNames.EmployeeID, typeof(System.Int32)));
            _PropertyDescriptors.Add("TerritoryID", new FieldDescriptor(EmployeeTerritoriesBOFieldNames.TerritoryID, typeof(System.String)));

            _AllFieldsList = new List<string>(2);
            _AllFieldsList.Add("EmployeeID");
            _AllFieldsList.Add("TerritoryID");

            _FieldDbTypes = new Dictionary<string, DbType>(2);
            _FieldDbTypes.Add("EmployeeID", DbType.Int32);
            _FieldDbTypes.Add("TerritoryID", DbType.String);

            _FieldEnums = new BusinessLayerFieldEnumDictionary(3);
            _FieldEnums.Add("EmployeeID", EmployeeTerritoriesBOFieldNames.EmployeeID);
            _FieldEnums.Add("TerritoryID", EmployeeTerritoriesBOFieldNames.TerritoryID);
            _FieldEnums.Add("CUSTOM_FIELD", EmployeeTerritoriesBOFieldNames.CUSTOM_FIELD);

            _FieldLengths = new Dictionary<string, int>(2);
            _FieldLengths.Add("EmployeeID", 0);
            _FieldLengths.Add("TerritoryID", 20);

            _FieldNativeDbTypes = new Dictionary<string, int>(2);
            _FieldNativeDbTypes.Add("EmployeeID", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("TerritoryID", (int)System.Data.SqlDbType.NVarChar);

            _FieldPermissionKeys = new Dictionary<string, string>(2);

        }

        private static bool _AreCustomDescriptorsEvaluated = false;
        protected override bool AreCustomDescriptorsEvaluated
        {
            get
            {
                bool llReturn = _AreCustomDescriptorsEvaluated;
                _AreCustomDescriptorsEvaluated = true;
                return llReturn;
            }
        }

        private static PropertyDescriptorDictionary _PropertyDescriptors;
        protected override PropertyDescriptorDictionary PropertyDescriptors
        {
            get
            {
                return _PropertyDescriptors;
            }
        }

        /// <summary>
        /// A PropertyDescriptor class used to Get and Set the value of fields within the EmployeeTerritoriesBO business object.
        /// </summary>
        private class FieldDescriptor :
        MicroFour.StrataFrame.Business.FieldPropertyDescriptor<EmployeeTerritoriesBOFieldNames>
        {
            public FieldDescriptor(EmployeeTerritoriesBOFieldNames field, Type fieldType) :
                base(field, fieldType) { }
            private static Type _ComponentType = typeof(EmployeeTerritoriesBO);
            public override object GetValue(object component)
            {
                switch (this.Field)
                {
                    case EmployeeTerritoriesBOFieldNames.EmployeeID:
                        return ((EmployeeTerritoriesBO)component).EmployeeID;
                    case EmployeeTerritoriesBOFieldNames.TerritoryID:
                        return ((EmployeeTerritoriesBO)component).TerritoryID;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override void SetValue(object component, object value)
            {
                switch (this.Field)
                {
                    case EmployeeTerritoriesBOFieldNames.EmployeeID:
                        ((EmployeeTerritoriesBO)component).EmployeeID = (System.Int32)value;
                        break;
                    case EmployeeTerritoriesBOFieldNames.TerritoryID:
                        ((EmployeeTerritoriesBO)component).TerritoryID = (System.String)value;
                        break;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override Type ComponentType
            {
                get
                {
                    return _ComponentType;
                }
            }
        }

        #endregion

    }

}
