using MicroFour.StrataFrame.Business;
using MicroFour.StrataFrame.Security;
using MicroFour.StrataFrame.UI.Windows.Forms;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;

namespace NotRefreshBusiness
{
    partial class EmployeesBO
    {

        #region Component Implementation

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            components = new System.ComponentModel.Container();

            this.CheckRulesOnCurrentRow += new CheckRulesOnCurrentRowEventHandler(BusinessObject1_CheckRulesOnCurrentRow);
            this.SetDefaultValues += new SetDefaultValuesEventHandler(BusinessObject1_SetDefaultValues);
        }

        #endregion


        #region BusinessLayer Overriden Methods & Properties

        /// <summary>
        /// The collection of required fields for the business object.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override RequiredFieldsCollection RequiredFields
        {
            get
            {
                return base.RequiredFields;
            }
            set
            {
                base.RequiredFields = value;
            }
        }

        /// <summary>
        /// Defines the constraint that defines the parent-child relationship between this business object type and another business object type.
        /// </summary>
        [Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override IBusinessParentRelationship ParentRelationship
        {
            get
            {
                return base.ParentRelationship;
            }
            set
            {
                base.ParentRelationship = value;
            }
        }

        /// <summary>
        /// Returns all of the field names in a single string in the form of [field1],[field2],...  This must be used in the place of '*' in select statements if Query Notifications are to be registered.
        /// </summary>
        protected override String AllFieldNames
        {
            get
            {
                return "[EmployeeID],[LastName],[FirstName],[Title],[TitleOfCourtesy],[BirthDate],[HireDate],[Address],[City],[Region],[PostalCode],[Country],[HomePhone],[Extension],[Photo],[Notes],[ReportsTo],[PhotoPath]";
            }
        }

        /// <summary>
        /// The name of the database that contains the table to which this business object is mapped.
        /// </summary>
        public override String Database
        {
            get
            {
                return "Northwind";
            }
        }

        private static string[] _PrimaryKeyFields = new string[] { "EmployeeID" };
        /// <summary>
        /// Gets the field or fields that comprise the primary key for the business object.
        /// </summary>
        public override string[] PrimaryKeyFields
        {
            get
            {
                return _PrimaryKeyFields;
            }
        }

        /// <summary>
        /// The name of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableName
        {
            get
            {
                return "Employees";
            }
        }

        /// <summary>
        /// The schema of the table in the database to which this business object is mapped.
        /// </summary>
        public override String TableSchema
        {
            get
            {
                return "dbo";
            }
        }

        /// <summary>
        /// Creates and returns an array of DataColumns that contains the schema for the table.  This is used to prevent a round trip to the server to aquire the initial schema for the internal DataTable.
        /// </summary>
        protected override DataColumn[] CreateTableSchema()
        {
            return new DataColumn[] {
new DataColumn("EmployeeID", typeof(System.Int32)),
new DataColumn("LastName", typeof(System.String)),
new DataColumn("FirstName", typeof(System.String)),
new DataColumn("Title", typeof(System.String)),
new DataColumn("TitleOfCourtesy", typeof(System.String)),
new DataColumn("BirthDate", typeof(System.DateTime)),
new DataColumn("HireDate", typeof(System.DateTime)),
new DataColumn("Address", typeof(System.String)),
new DataColumn("City", typeof(System.String)),
new DataColumn("Region", typeof(System.String)),
new DataColumn("PostalCode", typeof(System.String)),
new DataColumn("Country", typeof(System.String)),
new DataColumn("HomePhone", typeof(System.String)),
new DataColumn("Extension", typeof(System.String)),
new DataColumn("Photo", typeof(System.Byte[])),
new DataColumn("Notes", typeof(System.String)),
new DataColumn("ReportsTo", typeof(System.Int32)),
new DataColumn("PhotoPath", typeof(System.String))};
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected void AddBrokenRule(EmployeesBOFieldNames Field, string ErrorMessage)
        {
            base.AddBrokenRule(Field, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rule to the business object's collection
        /// </summary>
        protected new void AddBrokenRule(string FieldName, string ErrorMessage)
        {
            base.AddBrokenRule(FieldName, ErrorMessage);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected void AddBrokenRuleByKey(EmployeesBOFieldNames Field, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(Field, ErrorMessageKey);
        }

        /// <summary>
        /// Adds a broken rules to the business object's collection using the given message key to pull the error message from the localization database
        /// </summary>
        protected new void AddBrokenRuleByKey(string FieldName, string ErrorMessageKey)
        {
            base.AddBrokenRuleByKey(FieldName, ErrorMessageKey);
        }

        /// <summary>
        /// Gets a collection of the names for all fields that belong to this business object and map to the database.
        /// </summary>
        public override List<string> AllFieldsList
        {
            get
            {
                return _AllFieldsList;
            }
        }

        /// <summary>
        /// Gets a dictionary of the DbTypes for all fields that belong to this business object and map to the database.
        /// </summary>
        public override Dictionary<string, DbType> FieldDbTypes
        {
            get
            {
                return _FieldDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of all fields within this business object that map to the FieldNames enumeration for this business object.
        /// </summary>
        public override BusinessLayerFieldEnumDictionary FieldEnums
        {
            get
            {
                return _FieldEnums;
            }
        }

        /// <summary>
        /// Gets a dictionary of all of the lengths for all fields within this business object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldLengths
        {
            get
            {
                return _FieldLengths;
            }
        }

        /// <summary>
        /// Gets a dictionary of the native DbType (SqlDbType, OracleType, OleDbType, etc.) for all fields within this buisness object that map to a field in the database.
        /// </summary>
        public override Dictionary<string, int> FieldNativeDbTypes
        {
            get
            {
                return _FieldNativeDbTypes;
            }
        }

        /// <summary>
        /// Gets a dictionary of the security permission keys for each field in the business object.
        /// </summary>
        public override Dictionary<string, string> FieldPermissionKeys
        {
            get
            {
                return _FieldPermissionKeys;
            }
        }

        #endregion

        #region Field Properties

        /// <summary>
        /// EmployeeID
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("EmployeeID"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 EmployeeID
        {
            get
            {
                return (System.Int32)this.CurrentRow["EmployeeID"];
            }
            set
            {
                this.CurrentRow["EmployeeID"] = value;
            }
        }

        /// <summary>
        /// LastName
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("LastName"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String LastName
        {
            get
            {
                return (System.String)this.CurrentRow["LastName"];
            }
            set
            {
                this.CurrentRow["LastName"] = value;
            }
        }

        /// <summary>
        /// FirstName
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("FirstName"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String FirstName
        {
            get
            {
                return (System.String)this.CurrentRow["FirstName"];
            }
            set
            {
                this.CurrentRow["FirstName"] = value;
            }
        }

        /// <summary>
        /// Title
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Title"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Title
        {
            get
            {
                return (System.String)this.CurrentRow["Title"];
            }
            set
            {
                this.CurrentRow["Title"] = value;
            }
        }

        /// <summary>
        /// TitleOfCourtesy
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("TitleOfCourtesy"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String TitleOfCourtesy
        {
            get
            {
                return (System.String)this.CurrentRow["TitleOfCourtesy"];
            }
            set
            {
                this.CurrentRow["TitleOfCourtesy"] = value;
            }
        }

        /// <summary>
        /// BirthDate
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("BirthDate"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime BirthDate
        {
            get
            {
                return (System.DateTime)this.CurrentRow["BirthDate"];
            }
            set
            {
                this.CurrentRow["BirthDate"] = value;
            }
        }

        /// <summary>
        /// HireDate
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("HireDate"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.DateTime HireDate
        {
            get
            {
                return (System.DateTime)this.CurrentRow["HireDate"];
            }
            set
            {
                this.CurrentRow["HireDate"] = value;
            }
        }

        /// <summary>
        /// Address
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Address"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Address
        {
            get
            {
                return (System.String)this.CurrentRow["Address"];
            }
            set
            {
                this.CurrentRow["Address"] = value;
            }
        }

        /// <summary>
        /// City
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("City"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String City
        {
            get
            {
                return (System.String)this.CurrentRow["City"];
            }
            set
            {
                this.CurrentRow["City"] = value;
            }
        }

        /// <summary>
        /// Region
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Region"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Region
        {
            get
            {
                return (System.String)this.CurrentRow["Region"];
            }
            set
            {
                this.CurrentRow["Region"] = value;
            }
        }

        /// <summary>
        /// PostalCode
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("PostalCode"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String PostalCode
        {
            get
            {
                return (System.String)this.CurrentRow["PostalCode"];
            }
            set
            {
                this.CurrentRow["PostalCode"] = value;
            }
        }

        /// <summary>
        /// Country
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Country"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Country
        {
            get
            {
                return (System.String)this.CurrentRow["Country"];
            }
            set
            {
                this.CurrentRow["Country"] = value;
            }
        }

        /// <summary>
        /// HomePhone
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("HomePhone"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String HomePhone
        {
            get
            {
                return (System.String)this.CurrentRow["HomePhone"];
            }
            set
            {
                this.CurrentRow["HomePhone"] = value;
            }
        }

        /// <summary>
        /// Extension
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Extension"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Extension
        {
            get
            {
                return (System.String)this.CurrentRow["Extension"];
            }
            set
            {
                this.CurrentRow["Extension"] = value;
            }
        }

        /// <summary>
        /// Photo
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Photo"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Byte[] Photo
        {
            get
            {
                return (System.Byte[])this.CurrentRow["Photo"];
            }
            set
            {
                this.CurrentRow["Photo"] = value;
            }
        }

        /// <summary>
        /// Notes
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("Notes"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String Notes
        {
            get
            {
                return (System.String)this.CurrentRow["Notes"];
            }
            set
            {
                this.CurrentRow["Notes"] = value;
            }
        }

        /// <summary>
        /// ReportsTo
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("ReportsTo"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.Int32 ReportsTo
        {
            get
            {
                return (System.Int32)this.CurrentRow["ReportsTo"];
            }
            set
            {
                this.CurrentRow["ReportsTo"] = value;
            }
        }

        /// <summary>
        /// PhotoPath
        /// </summary>
        [Browsable(false),
         BusinessFieldDisplayInEditor(),
         Description("PhotoPath"),
         DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public System.String PhotoPath
        {
            get
            {
                return (System.String)this.CurrentRow["PhotoPath"];
            }
            set
            {
                this.CurrentRow["PhotoPath"] = value;
            }
        }

        #endregion

        #region Field Property Events

        #endregion

        #region Nested Types & Field Security

        /// <summary>
        /// Contains all of the field names that belong to the business object.
        /// </summary>
        public enum EmployeesBOFieldNames
        {
            EmployeeID,
            LastName,
            FirstName,
            Title,
            TitleOfCourtesy,
            BirthDate,
            HireDate,
            Address,
            City,
            Region,
            PostalCode,
            Country,
            HomePhone,
            Extension,
            Photo,
            Notes,
            ReportsTo,
            PhotoPath,
            CUSTOM_FIELD
        }

        /// <summary>
        /// Gets the System.Type of the enumeration that contains the field names for the business object.
        /// </summary>
        public override System.Type GetFieldEnumType()
        {
            return typeof(EmployeesBOFieldNames);
        }

        /// <summary>
        /// Creates a new CheckFieldSecurityEventArgs object that can be used with this business object type.
        /// </summary>
        protected override CheckFieldSecurityEventArgsBase CreateNewFieldSecurityEventArgs(System.Enum Field, string CustomField, string PermissionKey, PermissionInfo Perm)
        {
            return new CheckFieldSecurityEventArgs<EmployeesBOFieldNames>(Field, CustomField, PermissionKey, Perm);
        }

        /// <summary>
        /// Describes a method that will handle the CheckFieldScurity event.
        /// </summary>
        public delegate void CheckFieldSecurityEventHandler(object sender, CheckFieldSecurityEventArgs<EmployeesBOFieldNames> e);

        /// <summary>
        /// Occurs when the business objects needs to check the security on a field.
        /// </summary>
        public event CheckFieldSecurityEventHandler CheckFieldSecurity;

        /// <summary>
        /// Raises the CheckFieldSecurity event.
        /// </summary>
        protected override void OnCheckFieldSecurity(CheckFieldSecurityEventArgsBase e)
        {
            if (this.CheckFieldSecurity != null)
            {
                this.CheckFieldSecurity(this, (CheckFieldSecurityEventArgs<EmployeesBOFieldNames>)e);
            }
        }

        #endregion

        #region Item Property Implementation


        private static List<string> _AllFieldsList;
        private static Dictionary<string, DbType> _FieldDbTypes;
        private static BusinessLayerFieldEnumDictionary _FieldEnums;
        private static Dictionary<string, int> _FieldLengths;
        private static Dictionary<string, int> _FieldNativeDbTypes;
        private static Dictionary<string, string> _FieldPermissionKeys;

        /// <summary>
        /// Initializes the static members of the EmployeesBO class.
        /// </summary>
        static EmployeesBO()
        {
            //-- Create the new shared dictionary and populate it with an 
            //   instance of each property descriptor
            _PropertyDescriptors = new PropertyDescriptorDictionary(23);
            _PropertyDescriptors.Add("EmployeeID", new FieldDescriptor(EmployeesBOFieldNames.EmployeeID, typeof(System.Int32)));
            _PropertyDescriptors.Add("LastName", new FieldDescriptor(EmployeesBOFieldNames.LastName, typeof(System.String)));
            _PropertyDescriptors.Add("FirstName", new FieldDescriptor(EmployeesBOFieldNames.FirstName, typeof(System.String)));
            _PropertyDescriptors.Add("Title", new FieldDescriptor(EmployeesBOFieldNames.Title, typeof(System.String)));
            _PropertyDescriptors.Add("TitleOfCourtesy", new FieldDescriptor(EmployeesBOFieldNames.TitleOfCourtesy, typeof(System.String)));
            _PropertyDescriptors.Add("BirthDate", new FieldDescriptor(EmployeesBOFieldNames.BirthDate, typeof(System.DateTime)));
            _PropertyDescriptors.Add("HireDate", new FieldDescriptor(EmployeesBOFieldNames.HireDate, typeof(System.DateTime)));
            _PropertyDescriptors.Add("Address", new FieldDescriptor(EmployeesBOFieldNames.Address, typeof(System.String)));
            _PropertyDescriptors.Add("City", new FieldDescriptor(EmployeesBOFieldNames.City, typeof(System.String)));
            _PropertyDescriptors.Add("Region", new FieldDescriptor(EmployeesBOFieldNames.Region, typeof(System.String)));
            _PropertyDescriptors.Add("PostalCode", new FieldDescriptor(EmployeesBOFieldNames.PostalCode, typeof(System.String)));
            _PropertyDescriptors.Add("Country", new FieldDescriptor(EmployeesBOFieldNames.Country, typeof(System.String)));
            _PropertyDescriptors.Add("HomePhone", new FieldDescriptor(EmployeesBOFieldNames.HomePhone, typeof(System.String)));
            _PropertyDescriptors.Add("Extension", new FieldDescriptor(EmployeesBOFieldNames.Extension, typeof(System.String)));
            _PropertyDescriptors.Add("Photo", new FieldDescriptor(EmployeesBOFieldNames.Photo, typeof(System.Byte[])));
            _PropertyDescriptors.Add("Notes", new FieldDescriptor(EmployeesBOFieldNames.Notes, typeof(System.String)));
            _PropertyDescriptors.Add("ReportsTo", new FieldDescriptor(EmployeesBOFieldNames.ReportsTo, typeof(System.Int32)));
            _PropertyDescriptors.Add("PhotoPath", new FieldDescriptor(EmployeesBOFieldNames.PhotoPath, typeof(System.String)));

            _AllFieldsList = new List<string>(18);
            _AllFieldsList.Add("EmployeeID");
            _AllFieldsList.Add("LastName");
            _AllFieldsList.Add("FirstName");
            _AllFieldsList.Add("Title");
            _AllFieldsList.Add("TitleOfCourtesy");
            _AllFieldsList.Add("BirthDate");
            _AllFieldsList.Add("HireDate");
            _AllFieldsList.Add("Address");
            _AllFieldsList.Add("City");
            _AllFieldsList.Add("Region");
            _AllFieldsList.Add("PostalCode");
            _AllFieldsList.Add("Country");
            _AllFieldsList.Add("HomePhone");
            _AllFieldsList.Add("Extension");
            _AllFieldsList.Add("Photo");
            _AllFieldsList.Add("Notes");
            _AllFieldsList.Add("ReportsTo");
            _AllFieldsList.Add("PhotoPath");

            _FieldDbTypes = new Dictionary<string, DbType>(18);
            _FieldDbTypes.Add("EmployeeID", DbType.Int32);
            _FieldDbTypes.Add("LastName", DbType.String);
            _FieldDbTypes.Add("FirstName", DbType.String);
            _FieldDbTypes.Add("Title", DbType.String);
            _FieldDbTypes.Add("TitleOfCourtesy", DbType.String);
            _FieldDbTypes.Add("BirthDate", DbType.DateTime);
            _FieldDbTypes.Add("HireDate", DbType.DateTime);
            _FieldDbTypes.Add("Address", DbType.String);
            _FieldDbTypes.Add("City", DbType.String);
            _FieldDbTypes.Add("Region", DbType.String);
            _FieldDbTypes.Add("PostalCode", DbType.String);
            _FieldDbTypes.Add("Country", DbType.String);
            _FieldDbTypes.Add("HomePhone", DbType.String);
            _FieldDbTypes.Add("Extension", DbType.String);
            _FieldDbTypes.Add("Photo", DbType.Binary);
            _FieldDbTypes.Add("Notes", DbType.String);
            _FieldDbTypes.Add("ReportsTo", DbType.Int32);
            _FieldDbTypes.Add("PhotoPath", DbType.String);

            _FieldEnums = new BusinessLayerFieldEnumDictionary(19);
            _FieldEnums.Add("EmployeeID", EmployeesBOFieldNames.EmployeeID);
            _FieldEnums.Add("LastName", EmployeesBOFieldNames.LastName);
            _FieldEnums.Add("FirstName", EmployeesBOFieldNames.FirstName);
            _FieldEnums.Add("Title", EmployeesBOFieldNames.Title);
            _FieldEnums.Add("TitleOfCourtesy", EmployeesBOFieldNames.TitleOfCourtesy);
            _FieldEnums.Add("BirthDate", EmployeesBOFieldNames.BirthDate);
            _FieldEnums.Add("HireDate", EmployeesBOFieldNames.HireDate);
            _FieldEnums.Add("Address", EmployeesBOFieldNames.Address);
            _FieldEnums.Add("City", EmployeesBOFieldNames.City);
            _FieldEnums.Add("Region", EmployeesBOFieldNames.Region);
            _FieldEnums.Add("PostalCode", EmployeesBOFieldNames.PostalCode);
            _FieldEnums.Add("Country", EmployeesBOFieldNames.Country);
            _FieldEnums.Add("HomePhone", EmployeesBOFieldNames.HomePhone);
            _FieldEnums.Add("Extension", EmployeesBOFieldNames.Extension);
            _FieldEnums.Add("Photo", EmployeesBOFieldNames.Photo);
            _FieldEnums.Add("Notes", EmployeesBOFieldNames.Notes);
            _FieldEnums.Add("ReportsTo", EmployeesBOFieldNames.ReportsTo);
            _FieldEnums.Add("PhotoPath", EmployeesBOFieldNames.PhotoPath);
            _FieldEnums.Add("CUSTOM_FIELD", EmployeesBOFieldNames.CUSTOM_FIELD);

            _FieldLengths = new Dictionary<string, int>(18);
            _FieldLengths.Add("EmployeeID", 0);
            _FieldLengths.Add("LastName", 20);
            _FieldLengths.Add("FirstName", 10);
            _FieldLengths.Add("Title", 30);
            _FieldLengths.Add("TitleOfCourtesy", 25);
            _FieldLengths.Add("BirthDate", 0);
            _FieldLengths.Add("HireDate", 0);
            _FieldLengths.Add("Address", 60);
            _FieldLengths.Add("City", 15);
            _FieldLengths.Add("Region", 15);
            _FieldLengths.Add("PostalCode", 10);
            _FieldLengths.Add("Country", 15);
            _FieldLengths.Add("HomePhone", 24);
            _FieldLengths.Add("Extension", 4);
            _FieldLengths.Add("Photo", 2147483647);
            _FieldLengths.Add("Notes", 1073741823);
            _FieldLengths.Add("ReportsTo", 0);
            _FieldLengths.Add("PhotoPath", 255);

            _FieldNativeDbTypes = new Dictionary<string, int>(18);
            _FieldNativeDbTypes.Add("EmployeeID", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("LastName", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("FirstName", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("Title", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("TitleOfCourtesy", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("BirthDate", (int)System.Data.SqlDbType.DateTime);
            _FieldNativeDbTypes.Add("HireDate", (int)System.Data.SqlDbType.DateTime);
            _FieldNativeDbTypes.Add("Address", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("City", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("Region", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("PostalCode", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("Country", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("HomePhone", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("Extension", (int)System.Data.SqlDbType.NVarChar);
            _FieldNativeDbTypes.Add("Photo", (int)System.Data.SqlDbType.Image);
            _FieldNativeDbTypes.Add("Notes", (int)System.Data.SqlDbType.NText);
            _FieldNativeDbTypes.Add("ReportsTo", (int)System.Data.SqlDbType.Int);
            _FieldNativeDbTypes.Add("PhotoPath", (int)System.Data.SqlDbType.NVarChar);

            _FieldPermissionKeys = new Dictionary<string, string>(18);

        }

        private static bool _AreCustomDescriptorsEvaluated = false;
        protected override bool AreCustomDescriptorsEvaluated
        {
            get
            {
                bool llReturn = _AreCustomDescriptorsEvaluated;
                _AreCustomDescriptorsEvaluated = true;
                return llReturn;
            }
        }

        private static PropertyDescriptorDictionary _PropertyDescriptors;
        protected override PropertyDescriptorDictionary PropertyDescriptors
        {
            get
            {
                return _PropertyDescriptors;
            }
        }

        /// <summary>
        /// A PropertyDescriptor class used to Get and Set the value of fields within the EmployeesBO business object.
        /// </summary>
        private class FieldDescriptor :
        MicroFour.StrataFrame.Business.FieldPropertyDescriptor<EmployeesBOFieldNames>
        {
            public FieldDescriptor(EmployeesBOFieldNames field, Type fieldType) :
                base(field, fieldType) { }
            private static Type _ComponentType = typeof(EmployeesBO);
            public override object GetValue(object component)
            {
                switch (this.Field)
                {
                    case EmployeesBOFieldNames.EmployeeID:
                        return ((EmployeesBO)component).EmployeeID;
                    case EmployeesBOFieldNames.LastName:
                        return ((EmployeesBO)component).LastName;
                    case EmployeesBOFieldNames.FirstName:
                        return ((EmployeesBO)component).FirstName;
                    case EmployeesBOFieldNames.Title:
                        return ((EmployeesBO)component).Title;
                    case EmployeesBOFieldNames.TitleOfCourtesy:
                        return ((EmployeesBO)component).TitleOfCourtesy;
                    case EmployeesBOFieldNames.BirthDate:
                        return ((EmployeesBO)component).BirthDate;
                    case EmployeesBOFieldNames.HireDate:
                        return ((EmployeesBO)component).HireDate;
                    case EmployeesBOFieldNames.Address:
                        return ((EmployeesBO)component).Address;
                    case EmployeesBOFieldNames.City:
                        return ((EmployeesBO)component).City;
                    case EmployeesBOFieldNames.Region:
                        return ((EmployeesBO)component).Region;
                    case EmployeesBOFieldNames.PostalCode:
                        return ((EmployeesBO)component).PostalCode;
                    case EmployeesBOFieldNames.Country:
                        return ((EmployeesBO)component).Country;
                    case EmployeesBOFieldNames.HomePhone:
                        return ((EmployeesBO)component).HomePhone;
                    case EmployeesBOFieldNames.Extension:
                        return ((EmployeesBO)component).Extension;
                    case EmployeesBOFieldNames.Photo:
                        return ((EmployeesBO)component).Photo;
                    case EmployeesBOFieldNames.Notes:
                        return ((EmployeesBO)component).Notes;
                    case EmployeesBOFieldNames.ReportsTo:
                        return ((EmployeesBO)component).ReportsTo;
                    case EmployeesBOFieldNames.PhotoPath:
                        return ((EmployeesBO)component).PhotoPath;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override void SetValue(object component, object value)
            {
                switch (this.Field)
                {
                    case EmployeesBOFieldNames.EmployeeID:
                        ((EmployeesBO)component).EmployeeID = (System.Int32)value;
                        break;
                    case EmployeesBOFieldNames.LastName:
                        ((EmployeesBO)component).LastName = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.FirstName:
                        ((EmployeesBO)component).FirstName = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.Title:
                        ((EmployeesBO)component).Title = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.TitleOfCourtesy:
                        ((EmployeesBO)component).TitleOfCourtesy = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.BirthDate:
                        ((EmployeesBO)component).BirthDate = (System.DateTime)value;
                        break;
                    case EmployeesBOFieldNames.HireDate:
                        ((EmployeesBO)component).HireDate = (System.DateTime)value;
                        break;
                    case EmployeesBOFieldNames.Address:
                        ((EmployeesBO)component).Address = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.City:
                        ((EmployeesBO)component).City = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.Region:
                        ((EmployeesBO)component).Region = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.PostalCode:
                        ((EmployeesBO)component).PostalCode = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.Country:
                        ((EmployeesBO)component).Country = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.HomePhone:
                        ((EmployeesBO)component).HomePhone = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.Extension:
                        ((EmployeesBO)component).Extension = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.Photo:
                        ((EmployeesBO)component).Photo = (System.Byte[])value;
                        break;
                    case EmployeesBOFieldNames.Notes:
                        ((EmployeesBO)component).Notes = (System.String)value;
                        break;
                    case EmployeesBOFieldNames.ReportsTo:
                        ((EmployeesBO)component).ReportsTo = (System.Int32)value;
                        break;
                    case EmployeesBOFieldNames.PhotoPath:
                        ((EmployeesBO)component).PhotoPath = (System.String)value;
                        break;
                    default:
                        throw new BusinessLayerException("Field not supported.");
                }
            }
            public override Type ComponentType
            {
                get
                {
                    return _ComponentType;
                }
            }
        }

        #endregion

    }

}
